/* 
 * Author: Luis Useche <lusec001@cs.fiu.edu>
 * Date: April 3, 2007
 */
#include <linux/init.h>
#include <linux/module.h>
#include <linux/kernel.h>

#include <linux/blkdev.h>

/*It is important to update the device to be intercepted here*/
#define interc_bdev bdget(MKDEV(8,0))

MODULE_LICENSE("GPL");
MODULE_AUTHOR("Luis Useche <lusec001@cs.fiu.edu>");
MODULE_DESCRIPTION("Print the information of a block device");

make_request_fn *original_make_request_fn;

static int my_make_request(request_queue_t *q, struct bio *bio);

/*module initialization*/
int __init init_module(void) {
  request_queue_t *q;

  q = bdev_get_queue(intec_bdev);
  original_make_request_fn = q->make_request_fn;
  
  q->make_request_fn = my_make_request;
  
  return 0;
}

/*module finalization*/
void __exit cleanup_module(void) {
  request_queue_t *q;

  q = bdev_get_queue(interc_bdev);
  
  q->make_request_fn = original_make_request_fn;
}

static int my_make_request(request_queue_t *q, struct bio *bio) {
  printk("HI INTERCEPTED!!!\n");
  
  return original_make_request_fn(q,bio);
}
